VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6630
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   11955
   LinkTopic       =   "Form1"
   ScaleHeight     =   6630
   ScaleWidth      =   11955
   StartUpPosition =   3  'Windows Default
   Begin Project1.ucListView ucListView1 
      Height          =   5055
      Left            =   0
      TabIndex        =   4
      Top             =   0
      Width           =   8055
      _ExtentX        =   14208
      _ExtentY        =   8916
   End
   Begin VB.Frame Frame1 
      Caption         =   "Frame1"
      Height          =   8295
      Left            =   9480
      TabIndex        =   1
      Top             =   0
      Width           =   1815
      Begin VB.CommandButton Command2 
         Caption         =   "Command2"
         Height          =   255
         Left            =   240
         TabIndex        =   3
         Top             =   7800
         Width           =   1335
      End
      Begin VB.CommandButton Command1 
         Caption         =   "Command1"
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   480
         Width           =   1335
      End
   End
   Begin VB.VScrollBar FramScroll 
      Height          =   7695
      LargeChange     =   555
      Left            =   11400
      Max             =   235
      TabIndex        =   0
      Top             =   120
      Width           =   255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Const PM_REMOVE = &H1

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type msg
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

Private Declare Function PeekMessage Lib "user32" Alias "PeekMessageA" (lpMsg As msg, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long, ByVal wRemoveMsg As Long) As Long
Private Declare Function WaitMessage Lib "user32" () As Long
Private bCancel As Boolean
Private Const WM_MOUSEWHEEL = 522

Private lastVal As Long

Private Sub ProcessMessages()

    Dim message As msg

On Error Resume Next

    Do While Not bCancel
        WaitMessage 'Wait For message and...
        If PeekMessage(message, Me.hwnd, WM_MOUSEWHEEL, WM_MOUSEWHEEL, PM_REMOVE) Then '...when the mousewheel is used...
            If message.wParam < 0 Then '...scroll up...
            'Me.Top = Me.Top + 240
                If (FramScroll.Value + FramScroll.LargeChange) <= FramScroll.Max Then
                    FramScroll.Value = FramScroll.Value + FramScroll.LargeChange
                Else
                    FramScroll.Value = FramScroll.Max
                End If
                Call FramScroll_Change

                Else '... or scroll down
                'Me.Top = Me.Top - 240
                If (FramScroll.Value - FramScroll.LargeChange) >= FramScroll.Min Then
                    FramScroll.Value = FramScroll.Value - FramScroll.LargeChange
                Else
                    FramScroll.Value = FramScroll.Min
                End If
                Call FramScroll_Change

            End If
        End If
        DoEvents
    Loop
End Sub

Private Sub Form_Load()
    InitLvw
    GenerateSampleRows
    
    Me.AutoRedraw = True
    Me.Show
    
    ProcessMessages
    
End Sub

Private Sub GenerateSampleRows()
    Dim i       As Integer
    
    For i = 0 To 500
        ucListView1.ItemAdd i, "Text " & i
        ucListView1.SubItemText(i, 3) = Int(Rnd * 100)
    Next
End Sub

Private Sub InitLvw()
    With ucListView1
        Call .Initialize
        Call .InitializeImageListSmall
        'Call .InitializeImageListLarge(48, 48)
        Call .InitializeImageListHeader
        
        Call .ColumnAdd(0, "Header 1", 150, [caLeft])
        Call .ColumnAdd(1, "Header 2", 100, [caRight])
        Call .ColumnAdd(2, "Header 3", 100, [caCenter])
        Call .ColumnAdd(3, "Header 4", 100, [caCenter])
        Call .ColumnAdd(4, "Header 5", 100, [caCenter])
        
        .ProgressColumn = 3
        .ProgressFillColor = &HFFCCAA
        
        .ViewMode = vmDetails
        .BackColor = &HF2FFFE
        .GridLines = True
        .CheckBoxes = True
        .FullRowSelect = True
        .BorderStyle = bsThin
        .MultiSelect = True
        .RaiseSubItemPrePaint = True 'Force OnSubItemPrePaint() event
        '.SubItemImages = True
    End With
End Sub

Private Sub Form_Resize()
    
    ucListView1.Width = Me.ScaleWidth - FramScroll.Width - Frame1.Width
    ucListView1.Height = Me.ScaleHeight
    
    Frame1.Top = (-1 * lastVal): Frame1.Left = Me.ScaleWidth - Frame1.Width - FramScroll.Width
    FramScroll.Top = 0: FramScroll.Left = Me.ScaleWidth - FramScroll.Width
    
    If Frame1.Height > Me.ScaleHeight Then
        FramScroll.Max = Frame1.Height - Me.ScaleHeight
        FramScroll.LargeChange = FramScroll.Max
    End If
    
    FramScroll.Height = Me.ScaleHeight
End Sub

Private Sub FramScroll_Change()
    Dim CurrVal As Long
    
    CurrVal = FramScroll.Value
    Frame1.Top = Frame1.Top - (CurrVal - lastVal) '* Screen.TwipsPerPixelY
        
    lastVal = CurrVal

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    bCancel = True
End Sub
